function MCVEM(Observation,Original,Initialization,NbrNeigh,NbrClass,NameFile)
%%
%%
%%%%%%%%%%
%%  INPUT
%%%%%%%%%%
%%  
%%  0bservation : matrix I x J
%%      Observed picture
%%  Original : matrix I x J, or : []
%%      Original image when available.
%%  Initialization : matrix I x J, or []
%%      Initial segmentation when available.
%%  NbrNeigh : character string
%%      '4-Neigh' or '8-Neigh' (number of neighbors).
%%  NbrClass : integer
%%      Number of class for the segmentation.
%%  NameFile : character string
%%      Name of the output file.
%%
%%%%%%%%%%%
%%  OUTPUT
%%%%%%%%%%%%
%%  The results are saved in a .mat file with name 'NameFile'.
%%
%%  The description of the different saved variables
%%  are in the file 'InterfaceMCVEM.m'
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Example of call of this function:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  See the file ExampleMCVEM.m
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


addpath MEXfiles/.
addpath CodesMCVEM/.


if (nargin~=6)
    disp(sprintf('6 input variables are required'));
    return;
end;


ObsPict=Observation;


if sum(size(Original))==0,
    PictAvailable=0;
else
    TruePict=Original;
    PictAvailable=1;
end;


if sum(size(Initialization))==0,
    InitAvailable=0;
else
    InitPartition=Initialization;
    InitAvailable=1;
end;


G=NbrClass;

InterfaceMCVEM;

if PictAvailable==0
    save(NameFile,'G','NbrNeigh','HatZ','Mu','HQdist','Sigma2','Beta','DeltaSegm','MethSimul','InitChainMethod','BurnIn','NbrSimulMin','NbrSimul','NbrIterQ','DiagCvgQ','DiagCvgNR','Initialization');
else
   save(NameFile,'G','NbrNeigh','HatZ','Mu','Sigma2','HQdist','Beta','DeltaSegm','Error','MethSimul','InitChainMethod','BurnIn','NbrSimulMin','NbrSimul','NbrIterQ','DiagCvgQ','DiagCvgNR','Initialization');
end; 

rmpath MEXfiles/.
rmpath CodesMCVEM/.